var app = {
    pid: '',
    upload_url: '',
    init: function(){
        app.bindEvents()
	},
	bindEvents : function(){
        chrome.extension.onMessage.addListener(function(request, sender, sendResponse){
            switch(request.action){
                case 'saveUser':
                    app.saveUser(request.name);
                    break;
            }
        });

        chrome.tabs.onUpdated.addListener(function(tabId,changeInfo,tab){
            if(changeInfo.status == "complete" ){
                if(typeof tab.url != "undefined"){
                    if(tab.url.indexOf(".ariticapp.com") > -1){
                        app.sendMessage("pageLoaded", {'source':'aritic'}, null, tabId)
                    }
                    if(tab.url.indexOf(".pipedrive.com") > -1){
                        app.sendMessage("pageLoaded", {'source':'pipedrive'}, null, tabId)
                    }
                    
                    if(tab.url.indexOf(".hubspot.com") > -1){
                        app.sendMessage("pageLoaded", {'source':'hubspot'}, null, tabId)
                    }
    
                    if(tab.url.indexOf(".close.com") > -1){
                        app.sendMessage("pageLoaded", {'source':'close'}, null, tabId)
                    }
                    
                    if(tab.url.indexOf(".sugarcrm.com") > -1){
                        app.sendMessage("pageLoaded", {'source':'sugar'}, null, tabId)
                    }
    
                    if(tab.url.indexOf(".zoho.com") > -1){
                        app.sendMessage("pageLoaded", {'source':'zoho'}, null, tabId)
                    }
                }

                if(typeof tab.openerTabId == "undefined"){
                    app.askToInjectContentScript();
                }
            }
        });

        chrome.tabs.onActiveChanged.addListener(function(tabId, changeInfo, tab) {
            setTimeout(function(){
                app.askToInjectContentScript();
            }, 1000)
        });
	},
	
    sendMessage: function(key, additional, callback, tabId){
        var options = tabId ? {} : {active: true, currentWindow: true};
        chrome.tabs.query(
            options,
            function(tabs) {
				if (chrome.runtime.lastError) {
                    console.log(chrome.runtime.lastError.message);
					return;
                }

                if(!tabs[0]) return;

                var params = {};
                params.key = key;
                if(additional){
                    for(var i in additional){
                        params[i] = additional[i];
                    }
                }
                if(tabId !== "*") {
                    chrome.tabs.sendMessage(tabId ? tabId: tabs[0].id, params, function(response) {
						if (chrome.runtime.lastError) {
							 console.log(chrome.runtime.lastError.message);
							return;
						}
                        if(typeof callback == "function"){
                            callback(response);
                        }
                    });
                } else {
                    var cbDone = false;
                    for(var t = 0; t < tabs.length; t++){

                        chrome.tabs.sendMessage(tabs[t].id, params, function(response) {
							if (chrome.runtime.lastError) {
									console.log(chrome.runtime.lastError.message);
									return;
							}
                            if(typeof callback == "function"){								
                                if(!cbDone){
                                    callback(response);
                                    cbDone = true;
                                }
                            }
                        });
                    }
                }
            }
        );
    },

    askToInjectContentScript: function () {
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
            if(tabs[0]){
                console.log("inject content")
                chrome.tabs.executeScript(tabs[0].id, {file: "inject.js"}, function(results) {
                    if (chrome.runtime.lastError) {
                        return;
                    }
                });
            }

        });
    },

    saveUser: function(name) {
        chrome.storage.sync.get(null, function (items) {
            var shazoom_users = [];
            if(items.shazoom_users){
                shazoom_users = JSON.parse(items.shazoom_users);
            }
            shazoom_users.push(name);
            var params = {};
            params['shazoom_users'] = JSON.stringify(shazoom_users);
            chrome.storage.sync.set(params, function () { });
        })
    }
};

app.init();

var log = "";
var rectraceApp = {
    chromeMediaSourceID: null,
    desktopMediaRequestId: null,
    chunkedUploader: null,
    chunkes: [],
    chunkBlob: null,
    upload_url: null,
    rrid: null,
    appState: "default",
    recordingPageTitle: null,
    currentTabId: null,
	recorder: null,
    currentStream: null,
	recordingInfo: {
        videoCodec: "videoCodec",
        alreadyHadGUMError: false,
        enableTabAudio: true
	},
    recordingState: {
        isRecording: false,
        isDesktopCapture: false,
        recordingType: null,
        startTime: null,
        tempTime: 0,
        isWebCamCapture: false,
        isFailed: false
	},
    init: function(){
        rectraceApp.bindChromeEvents()
	},

	bindChromeEvents : function(){
        rectraceApp.bindOnMessage();
        rectraceApp.bindOnClicked();
        rectraceApp.bindOnActiveChanged();
        rectraceApp.bindOnRemoved();
        rectraceApp.bindOnConnect();
        rectraceApp.bindOnUpdated();
        rectraceApp.bindOnInstalled();
	},

	bindOnMessage: function(){
        chrome.extension.onMessage.addListener(function(request, sender, sendResponse){

			switch(request.action){
                case 'capture' :
                    rectraceApp.getRecordingPageTitle();
                    rectraceApp.getCurrentTab();
                    rectraceApp.recordingInfo.enableTabAudio = request.audio;
                    if(request.type == "tab"){
                        rectraceApp.sendMessage("appendRecordingHtml", {type: request.type});
                        rectraceApp.captureTab(rectraceApp.recordingInfo.enableTabAudio);
                    } else if(request.type == "screen"){
                        rectraceApp.captureDesktop(false);
                    } else if(request.type == "webcam"){
                        rectraceApp.sendMessage("appendRecordingHtml", {type: request.type});
                    }
                    rectraceApp.appState = "waiting";
                    sendResponse({message: "done"});
                    break;

               /*  case 'webcamPreview':
                    rectraceApp.sendMessage("appendWebCamPreview");
                    break; */
                
                case 'smallwebcamPreview':
                    rectraceApp.sendMessage("appendSmallWebCamPreview");
                    break;

                case 'stopRecording':

                    rectraceApp.stopScreenRecording();
                    break;

                case 'startCapture':
                    rectraceApp.recordingState.recordingType = "capture";
                    if(request.type == "tab"){
                        rectraceApp.startTabRecording();
						if(request.enabled){
                            rectraceApp.sendMessage("appendSmallWebCamPreview");
                        } else {
                            rectraceApp.sendMessage("removeWebCamPreview");
                        }
                    } else if(request.type == "screen"){
						if(request.enabled){
                            rectraceApp.sendMessage("appendSmallWebCamPreview");
                        } else {
                            rectraceApp.sendMessage("removeWebCamPreview");
                        }
                        rectraceApp.startDesktopCapture(false);
                    }/*  else {
                        rectraceApp.startWebCamCapture()
                    } */
                    break;

                case 'cancellRecording':

                    rectraceApp.resetDefaults(true);
                    break;

                case 'pauseRecording':
                    rectraceApp.pauseRecording();
                    break;

                case 'resumeRecording':
                    rectraceApp.resumeRecording();
                    break;

                case 'refreshRecording':
                    rectraceApp.refreshRecording();
                    break;

                case 'upload_url':

                    rectraceApp.upload_url = request.upload_url;
                    rectraceApp.rrid = request.rrid ? request.rrid: null;
                    break;

                case 'checkDevicePermissions':
                    DetectRTC.load(function() {
                        var permissions = rectraceApp.detectDevicePermission();
                        permissions.key = "setDevicePermissions";
                        chrome.runtime.sendMessage(permissions);
                    });
                    break;

                case 'gotIt':
                    rectraceApp.sendMessage("appendGotIt");
                    rectraceApp.resetDefaults();
                    break;

                case 'tab_clicked':
                    if(request.tab === "webcam"){
                        rectraceApp.sendMessage("removeWebCamPreview");
                        rectraceApp.sendMessage("appendWebCamPreview");
                    } else {
                        rectraceApp.sendMessage("removeWebCamPreview");
                        if(request.webCam){
                            rectraceApp.sendMessage("appendSmallWebCamPreview");
                        }
  
                    } 
                    break;
                case 'camera_clicked':
                    if(request.tab !== "webcam"){
                        if(request.enabled){
                            rectraceApp.sendMessage("appendSmallWebCamPreview");
                        } else {
                            rectraceApp.sendMessage("removeWebCamPreview");
                        }
                    } 
                    break;
                
                case 'video_input_changed':
                    rectraceApp.sendMessage("reloadCameraIframe");
                    break;

                case 'abortUpload':

                    if(rectraceApp.uploader.xhr)
                        rectraceApp.uploader.xhr.abort();
                    break;
            }
        });
	},

	bindOnClicked: function() {
        chrome.browserAction.onClicked.addListener(function(tab) {
            if(rectraceApp.appState == "recording"){
                rectraceApp.stopScreenRecording();
            } else if (rectraceApp.appState == "waiting"){
                rectraceApp.sendMessage("stopWaiting");
            } 
        });
	},

	bindOnActiveChanged: function(){
        chrome.tabs.onActiveChanged.addListener(function(tabId, changeInfo, tab) {
			
			if(rectraceApp.recordingState.isRecording && rectraceApp.recordingState.isDesktopCapture){
                chrome.tabs.query({}, function(tabs) {
                    for (var i=0; i<tabs.length; ++i) {
                        if(tabs[i].id != tabId){
                            chrome.tabs.executeScript(tabs[i].id, {file: "removeHtml.js"}, function(results) {
                                if (chrome.runtime.lastError) {
                                    return;
                                } else {
                                }
                            });
                        }

                    }
                });
            }

            setTimeout(function(){
                rectraceApp.askToInjectContentScript();
            }, 1000)
        });



    },

    bindOnRemoved: function () {
        chrome.tabs.onRemoved.addListener(function(tabid, removed) {
            if(tabid === rectraceApp.currentTabId && rectraceApp.recordingState.isWebCamCapture && rectraceApp.recordingState.isRecording){
                rectraceApp.stopScreenRecording();
            }
        })
    },

	bindOnConnect : function () {
        chrome.extension.onConnect.addListener(function(port) {
            port.onDisconnect.addListener(function(msg) {
                rectraceApp.sendMessage("removeIframe");
            });
        });

        chrome.windows.onFocusChanged.addListener(function(window) {
			if(window > -1 && !rectraceApp.recordingState.isRecording){
				rectraceApp.sendMessage("removeWebCamPreview"); 
				rectraceApp.sendMessage("removeSmallWebCamPreview");
			}			            
        });

    },

	bindOnUpdated: function () {
        chrome.tabs.onUpdated.addListener(function(tabId,changeInfo,tab){
            if(changeInfo.status == "complete"){
                if(typeof tab.openerTabId == "undefined"){

                    var ap = false;
                    if((rectraceApp.recordingState.isDesktopCapture || (rectraceApp.currentTabId == tabId)) && rectraceApp.recordingState.isRecording ){
                        ap = true;
                    }

                    rectraceApp.askToInjectContentScript(ap);


                }
            }
        });
    },

	bindOnInstalled: function () {
       chrome.runtime.onInstalled.addListener(function (object) {
            chrome.tabs.create({url: "https://shazoom.io/shazoom-extension/setup?disable_editor=y"}, function (tab) {});
        });
    },

    getChromeVersion : function() {
        var raw = navigator.userAgent.match(/Chrom(e|ium)\/([0-9]+)\./);
        return raw ? parseInt(raw[2], 10) : 52;
    },

    captureTab: function(isNoAudio){
        var audioOptions = true;
        chrome.storage.sync.get(null, function(items) {
            if(items['audio-input']){
                audioOptions = {
                    optional: [
                        {sourceId: items['audio-input']}
                    ]
                }
            }
            var resolution = items['video-resolution'] || "1080";
            var maxResolution = rectraceApp.getMaxResolution(resolution);
            var constraints = {
                audio: isNoAudio === true ? false : true,
                video: true,
                videoConstraints: {
                    mandatory: {
                        minWidth: 16,
                        minHeight: 9,
                        maxWidth: maxResolution.width,
                        maxHeight: maxResolution.height,
                        maxFrameRate:60,
                        minFrameRate:25,
                        googLeakyBucket: true,
                        googNoiseReduction: true
                    },
                }
            };
    
            chrome.tabCapture.capture(constraints, function(stream) {
                rectraceApp.gotTabCaptureStream(stream, constraints);
            });
        })
        
	},

    gotTabCaptureStream: function(stream, constraints){
        if (!stream) {
            if (constraints.audio === true) {
                rectraceApp.captureTab(true);
                return;
            }
            setTimeout(function(){
                rectraceApp.sendMessage("stopStream");
                rectraceApp.resetDefaults();
            }, 50)
            console.log('Error starting tab capture: ' + (chrome.runtime.lastError.message || 'UNKNOWN'));
            return;
        }
        rectraceApp.createPackage(function() {
            console.log(app.pid + ' ' + app.upload_url);
        });
        rectraceApp.currentStream = stream;
	},

    startTabRecording: function () {
        rectraceApp.gotStream(rectraceApp.currentStream);
    },

    getMaxResolution: function (resolution){
        switch (resolution) {
            case "1080":
                return {
                    width: 1920,
                    height: 1080
                };
            case "720":
                return {
                    width: 1280,
                    height: 720
                };
            case "480":
                return {
                    width: 896,
                    height: 504
                };
            case "360":
                return {
                    width: 640,
                    height: 360
                }
        }
    },

    gotStream: function (stream) {
        rectraceApp.currentStream = stream;
        var constraints = {};
        if (rectraceApp.recordingInfo.enableTabAudio  ) {
            var audioOptions = true;
            chrome.storage.sync.get(null, function(items) {
                if(items['audio-input']){
                    audioOptions = {
                        optional: [
                            {sourceId: items['audio-input']}
                        ]
                    }
                } else {
                    audioOptions = {
                       /*  mandatory: {
                            googAutoGainControl: !0,
                            googEchoCancellation: !0,
                            googHighpassFilter: !0,
                            googNoiseSuppression: !0
                        } */
                    }
                }
                constraints.audio = audioOptions;
                constraints.video = false;
                navigator.webkitGetUserMedia(constraints, rectraceApp.addtrack, rectraceApp.getUserMediaError);
            })
            return;
        };

        rectraceApp.record(stream);
    },

    addtrack: function(stream){
        if(!rectraceApp.currentStream) return;
        rectraceApp.currentStream.addTrack(stream.getAudioTracks()[0]);
        rectraceApp.record(rectraceApp.currentStream);
    },

    stopScreenRecording: function () {
		rectraceApp.recordingState.isRecording = false;
        //rectraceApp.recorder.resume();
        clearInterval(rectraceApp.requestDataInterval);
		try{
			rectraceApp.recorder.stop();	
		}catch(ex){
			
		}
        
    },

    askToStopExternalStreams: function () {
        if(rectraceApp.recordingState.isDesktopCapture){
            rectraceApp.sendMessage("stopStream", null, undefined, "*");
        } else {
            if(rectraceApp.currentTabId){
                rectraceApp.sendMessage("stopStream", null, undefined, rectraceApp.currentTabId);
            }
        }
    },

    askToStartStopWatch: function () {
        // if(rectraceApp.recordingState.isDesktopCapture){
        // 	rectraceApp.sendMessage("startStopWatch");
        // } else {
        // 	if(rectraceApp.currentTabId){
        // 		sendMessage("startStopWatch", null, undefined, rectraceApp.currentTabId);
        // 	}
        // }
    },
    captureDesktop : function() {
		if (rectraceApp.recordingState.isRecording) {
			return;
		}
		if (rectraceApp.recorder && rectraceApp.recorder.stream && rectraceApp.recorder.stream.onended) {
			rectraceApp.recorder.stream.onended();
			return;
		}

    	var screenSources = ['screen',"window", "tab",  "audio"];

		try {
			console.log(chrome.desktopCapture.chooseDesktopMedia(screenSources, rectraceApp.onAccessApproved));
		} catch (e) {
			rectraceApp.getUserMediaError();
        }
	},

    onAccessApproved: function(chromeMediaSourceId) {
        rectraceApp.chromeMediaSourceID = chromeMediaSourceId;
        if (!rectraceApp.chromeMediaSourceID || !rectraceApp.chromeMediaSourceID.toString().length) {
            rectraceApp.sendMessage("stopStream");
            rectraceApp.resetDefaults();
            return;
        }
        if(rectraceApp.currentTabId){
            rectraceApp.sendMessage("appendRecordingHtml", {type: "screen"}, undefined, rectraceApp.currentTabId);
        } else {
            rectraceApp.sendMessage("appendRecordingHtml", {type: "screen"});
        }
    },

    getUserMediaError: function(err) {
        if (!rectraceApp.recordingInfo.alreadyHadGUMError) {
            rectraceApp.recordingInfo.alreadyHadGUMError = true;
            rectraceApp.recordingState.isRecording = false;
            rectraceApp.resetDefaults();
            return;
        }
    },

	resetDefaults: function(stopTrack) {
		if(stopTrack && rectraceApp.currentStream){
			var tracks = rectraceApp.currentStream.getTracks();
			if(tracks){
				for (var i = 0; i < tracks.length; ++i) {
					tracks[i].stop();
				}
			}

        }
        rectraceApp.chunkedUploader= null,
        rectraceApp.chunkes = [],
        rectraceApp.chunkBlob= null,
        rectraceApp.chunkIsWaiting = false;
		rectraceApp.recordingState.startTime = null;
        rectraceApp.recordingState.tempTime = null;
		rectraceApp.recorder = rectraceApp.chromeMediaSourceID = rectraceApp.desktopMediaRequestId = null;
		rectraceApp.currentStream = null;
        rectraceApp.recordingState.recordingType = null;
		rectraceApp.recordingPageTitle = "";
		rectraceApp.appState = "default";
		rectraceApp.recordingState.isDesktopCapture = rectraceApp.recordingState.isWebCamCapture = false;
		rectraceApp.upload_url = rectraceApp.rrid = null;
		chrome.browserAction.setBadgeText({text:""});
        chrome.browserAction.setPopup({popup: 'window.html'});
	},

    startDesktopCapture: function(){   
		rectraceApp.createPackage(function() {
           
			chrome.storage.sync.get(null, function(items) {
				var resolution = items['video-resolution'] || "1080";
				var maxResolution = rectraceApp.getMaxResolution(resolution);
				var constraints = {
					audio: false,
					video: {
						mandatory: {
							chromeMediaSource: 'desktop',
							chromeMediaSourceId: rectraceApp.chromeMediaSourceID,
							minWidth: 16,
							minHeight: 9,
							maxWidth: maxResolution.width,
							maxHeight: maxResolution.height
						},
						optional: []
					}
				};
		
				
				rectraceApp.recordingState.isDesktopCapture = true;
				navigator.webkitGetUserMedia(constraints, rectraceApp.gotStream, rectraceApp.getUserMediaError);
			});
			
			
        });
	},

    pauseRecording: function(){
        if(rectraceApp.recorder){
            rectraceApp.recordingState.tempTime = rectraceApp.recordingState.tempTime + ((Date.now() - rectraceApp.recordingState.startTime)/1000);
            rectraceApp.recordingState.startTime = null;
            rectraceApp.recorder.pause();
        }
    },

    resumeRecording: function(){
        if(rectraceApp.recorder){
            rectraceApp.recordingState.startTime = new Date();
            rectraceApp.recorder.resume();
        }
    },

    refreshRecording: function(){
        if(rectraceApp.recorder){
            rectraceApp.recorder.pause();
            rectraceApp.recorder.clearRecordedData();
            rectraceApp.recordingState.tempTime = 0;
            rectraceApp.recordingState.startTime = Date.now();
            rectraceApp.recorder.resume();
        }
    },

    record: function(stream){
        
		var options = {
			disableLogs: false
		};
		if (rectraceApp.recordingInfo.enableTabAudio) {
			options.audioBitsPerSecond = 128000;
			options.videoBitsPerSecond = 2200000;
		}

		options.mimeType = 'video/webm;codecs=vp8';
		rectraceApp.recorder =  new MediaRecorder(stream, options);
        rectraceApp.recordingState.startTime = Date.now();
		try {
            rectraceApp.recorder.start();
            rectraceApp.requestData();
            rectraceApp.recordingInfo.alreadyHadGUMError = false;
		} catch (e) {
            console.log(e)
            rectraceApp.getUserMediaError();
		}
		rectraceApp.recorder.stream = stream;

        rectraceApp.recordingState.isRecording = true;
        rectraceApp.recordingState.isFailed = false;
		rectraceApp.appState = "recording";
		chrome.browserAction.setBadgeText({text:"REC"});
		chrome.browserAction.setBadgeBackgroundColor({color:[238,31,107,1]});
        chrome.browserAction.setPopup({popup: ''});

		rectraceApp.askToStartStopWatch();
		rectraceApp.onRecording();
		rectraceApp.recorder.stream.onended = function() {
			if (rectraceApp.recorder && rectraceApp.recorder.stream) {
				rectraceApp.recorder.stream.onended = function() {};
			}

			rectraceApp.stopScreenRecording();
		};

		if(rectraceApp.recorder.stream.getVideoTracks()[0]){
            rectraceApp.recorder.stream.getVideoTracks()[0].onended = function() {
				if (rectraceApp.recorder && rectraceApp.recorder.stream && rectraceApp.recorder.stream.onended) {
                    rectraceApp.recorder.stream.onended();
				}
			};
		}
		if(rectraceApp.recorder.stream.getAudioTracks()[0]){
            rectraceApp.recorder.stream.getAudioTracks()[0].onended = function() {
				if (rectraceApp.recorder && rectraceApp.recorder.stream && rectraceApp.recorder.stream.onended) {
                    rectraceApp.recorder.stream.onended();
				}
			};
        }
        
        rectraceApp.recorder.ondataavailable = function (blob) {
           
            if(rectraceApp.recordingState.isFailed){
                rectraceApp.resetDefaults();
                return;
            }
            rectraceApp.chunkes.push(blob.data)    
            rectraceApp.chunkBlob = new Blob(rectraceApp.chunkes, { type:'video/webm;codecs=vp8'});
            var fileName = "Shazoom record " + Math.round(Math.random() * (9999999 - 1000000) + 1000000);
            var file = new File([rectraceApp.chunkBlob], fileName+ '.webm', {
                type: 'video/webm;codecs=vp8'
            });
            
            if(rectraceApp.upload_url){
                var isLast = !rectraceApp.recordingState.isRecording;
                file.isLast = isLast;
                if(!rectraceApp.chunkedUploader){
                    rectraceApp.chunkedUploader = new ChunkedUploader(file, {
                        fileName: fileName + '.webm',
                        url: rectraceApp.upload_url
                    })
                } else {
                    file.name = rectraceApp.chunkedUploader.file.name;
                    rectraceApp.chunkedUploader.file = file;
                }
                if(rectraceApp.chunkIsWaiting){
                    if(rectraceApp.chunkedUploader.range_start + rectraceApp.chunkedUploader.chunk_size < rectraceApp.chunkedUploader.file.size){
                        rectraceApp.chunkedUploader.range_end = rectraceApp.chunkedUploader.range_start + rectraceApp.chunkedUploader.chunk_size;
                        rectraceApp.chunkIsWaiting = false;
                        rectraceApp.chunkedUploader._upload(rectraceApp.chunkedUploader);
                    } else if(rectraceApp.chunkedUploader.file.isLast && (rectraceApp.chunkedUploader.range_start + rectraceApp.chunkedUploader.chunk_size >= rectraceApp.chunkedUploader.file.size)){
                        rectraceApp.chunkedUploader.range_end = rectraceApp.chunkedUploader.file.size;
                        rectraceApp.chunkIsWaiting = false;
                        rectraceApp.chunkedUploader._upload(rectraceApp.chunkedUploader);
                    } else {
                        rectraceApp.chunkIsWaiting = true;
                    }
                }
            } 

        };

        rectraceApp.recorder.onstop = function() {
            rectraceApp.askToStopExternalStreams();
            if(!rectraceApp.recorder) return;
            
           
            var tracks = rectraceApp.recorder.stream.getTracks();
            for (var i = 0; i < tracks.length; ++i) {
                tracks[i].stop();
            }
            
            if(rectraceApp.recordingState.isFailed){
                rectraceApp.resetDefaults();
                return;
            }
            rectraceApp.showNotification("Preview page will appear shortly");
			
            if(rectraceApp.upload_url){
                chrome.browserAction.setBadgeText({text:"uploading"});
                chrome.browserAction.setPopup({popup: ''});
            }
        }
    },
    
    requestData: function(){
        if(rectraceApp.upload_url){
            rectraceApp.requestDataInterval = setInterval(function(){
                rectraceApp.recorder.requestData();
            }, 3000)
        }
    },

    onRecording: function() {
        if (rectraceApp.recordingState.isRecording) {
            setTimeout(rectraceApp.onRecording, 800);
            return;
        }
    },
    openUploadPage: function(pid){
		
		window.open('https://shazoom.io/v/' + pid + "?ext=true");
		rectraceApp.currentTabId = null;
        rectraceApp.resetDefaults();
    },

    sendAjax: function(url, cb, err){
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url);
        xhr.onload = function() {
            if (xhr.status === 200) {
                if(typeof cb === "function"){
                    cb(xhr)
                }
            }
            else {
                if(typeof err === "function"){
                    err(xhr)
                }
            }
        };
        xhr.send();
    },

    sendMessage: function(key, additional, callback, tabId){
        var options = tabId ? {} : {active: true, currentWindow: true};
        chrome.tabs.query(
            options,
            function(tabs) {
				 if (chrome.runtime.lastError) {
				 console.log('of of errror');
				 return;
				 }
                if(!tabs[0]) return;
                var params = {};
                params.key = key;
                if(additional){
                    for(var i in additional){
                        params[i] = additional[i];
                    }
                }
                if(tabId !== "*" && tabId != 'shz_beside_active'){
                    chrome.tabs.sendMessage(tabId ? tabId: tabs[0].id, params, function(response) {
						if (chrome.runtime.lastError) {
							console.log(chrome.runtime.lastError.message);
							return;
						}
                        if(typeof callback != "undefined"){
                            callback(response);
                        }
                    });
                } else {
				
                    var cbDone = false;
                    for(var t = 0; t < tabs.length; t++){
						
						if(tabId == 'shz_beside_active' && tabs[t].active == true){
							continue;
						}

                        chrome.tabs.sendMessage(tabs[t].id, params, function(response) {
							if (chrome.runtime.lastError) {
								console.log(chrome.runtime.lastError.message);
								return;
							}
                            if(typeof callback != "undefined"){
                                if(!cbDone){
                                    callback(response);
                                    cbDone = true;
                                }
                            }
                        });
                    }
                }



            }
        );
    },

    getRecordingPageTitle: function(){
        rectraceApp.recordingPageTitle = "";
        rectraceApp.sendMessage("getTitle", null, function(response){
            rectraceApp.recordingPageTitle = response ? response.title: "";
        });
    },

    getCurrentTab: function(){
        chrome.tabs.query(
            {active: true, currentWindow: true},
            function(tabs) {
                if(tabs && tabs[0]) rectraceApp.currentTabId = tabs[0].id;
            }
        );
    },

    askToInjectContentScript: function (isReload) {

        chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
            if(tabs[0]){
                chrome.tabs.sendMessage(tabs[0].id, {ping: true}, function(response){
					 if (chrome.runtime.lastError) {
						 console.log(chrome.runtime.lastError.message)
                                //return;
                            }
							
							
					//if(rectraceApp.recordingState.isRecording && rectraceApp.recordingState.isDesktopCapture){
						rectraceApp.sendMessage("removeWebCamPreview", null, function(){}, 'shz_beside_active'); 
						rectraceApp.sendMessage("removeSmallWebCamPreview", null, function(){}, 'shz_beside_active');
					//}
					
                    if(response && response.pong) {
                        if(rectraceApp.recordingState.isRecording && rectraceApp.recordingState.isDesktopCapture){
                            rectraceApp.askToAppendRecordingHtml();
                        } else if (isReload){
                            rectraceApp.askToAppendRecordingHtml();
                        }

                    } else {
                        chrome.tabs.executeScript(tabs[0].id, {file: "rectraceContent.js"}, function(results) {
                            if (chrome.runtime.lastError) {
								console.log(chrome.runtime.lastError.message);
                                return;
                            } else {
                                if(rectraceApp.recordingState.isRecording && rectraceApp.recordingState.isDesktopCapture){
                                    rectraceApp.askToAppendRecordingHtml();
                                } else if (isReload){
                                    rectraceApp.askToAppendRecordingHtml();
                                }
                            }
                        });

                    }
                    chrome.tabs.executeScript(tabs[0].id, {file: "inject.js"}, function(results) {
                        if (chrome.runtime.lastError) {
                            return;
                        }
                    });
                });
            }

        });
    },

    askToAppendRecordingHtml: function(){
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
            if(tabs[0]){
                var now = Date.now();
                var time = 0;
                if(rectraceApp.recordingState.startTime){
                    time = (now - rectraceApp.recordingState.startTime) / 1000;
                }
                time += rectraceApp.recordingState.tempTime;
                chrome.tabs.sendMessage(tabs[0].id, {
                    appendHtml: true,
                    time: time,
                    isWebCamRecording: rectraceApp.recordingState.isWebCamCapture
                }, function(response){
					
					if (chrome.runtime.lastError) {
							console.log(chrome.runtime.lastError.message);
							return;
					}
					
				});
            }
        });
    },

    detectDevicePermission: function(){
        return {
            hasMicrophone: DetectRTC.hasMicrophone,
            isWebsiteHasMicrophonePermissions: DetectRTC.isWebsiteHasMicrophonePermissions,
            hasWebcam: DetectRTC.hasWebcam ,
            isWebsiteHasWebcamPermissions: DetectRTC.isWebsiteHasWebcamPermissions,
            videoInputs: DetectRTC.videoInputDevices,
            audioInputs: DetectRTC.audioInputDevices,
        }
    },

    showNotification: function (message) {
        chrome.notifications.create(null, {
            type: "basic",
            title: "processing",
            message: message,
            iconUrl: "logo_32.png"
        }, function (){ });
    },
    
    sendUploadInfoToPage: function(data){
		
		var data = {
			video_title: data.file.name,
			video_duration: data.duration,
			rid: data.rid			
		}
		
		rectraceApp.setMetaData(data, function(json){
			rectraceApp.openUploadPage(rectraceApp.pid)
			console.log(json);
			
		});
    },
    createPackage: function (cb) {
		
		
        fetch('https://shazoom.io/account_ajax.aspx?cmd=package.create')
        .then(function(response) {
            return response.json();
        })
        .then(function(myJson) {
            if (myJson.success === true) {
                rectraceApp.pid = myJson.pid;
                rectraceApp.upload_url = myJson.upload_url.replace(/&amp;/g, "&");
                cb && cb(myJson);
            }
        })
        .catch(function(err) {
            console.log(err);
        })
    },
    setMetaData: function (data, callback) {
						
		fetch("https://shazoom.io/account_ajax.aspx?cmd=package.set&pid=" + rectraceApp.pid, {
			method: 'POST',
			body: 'meta='+encodeURIComponent(JSON.stringify(data)),
			headers:{
			  'Content-Type': 'application/x-www-form-urlencoded' 
			}
		})
		.then(function(response) {
			return response.json();
		})
		.then(function(myJson) {
			console.log(myJson)
			callback && callback(myJson);
		})
		.catch(function(err) {
			console.log(err);
		})
    },
    newDateGenerator: function() {
        var date = new Date();
        var monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun",
        "Jul", "Aug", "September", "Oct", "Nove", "Dec"
        ];
        function formatAMPM(date) {
            var hours = date.getHours();
            var minutes = date.getMinutes();
            var ampm = hours >= 12 ? 'pm' : 'am';
            hours = hours % 12;
            hours = hours ? hours : 12; // the hour '0' should be '12'
            minutes = minutes < 10 ? '0'+minutes : minutes;
            var strTime = hours + ':' + minutes + ' ' + ampm;
            return strTime;
        }
        return monthNames[date.getMonth()] +  ' ' +  date.getDate() + ',' + ' ' + formatAMPM(date);
    }
};

rectraceApp.init();

function ChunkedUploader(file, options) {
    // options - {fileName : "", url: ""}
	var self = this;
	this.upload_request = new XMLHttpRequest();
	this.upload_request.onload = this._uploadSuccess(this);
	this.upload_error_count = 0;
    this.upload_failed_count = 0;
    this.file = file;
	this.upload_request.onerror = this._uploadFail(this);
	this.upload_request.onabort = this._uploadFail(this);
	var eventSource = this.upload_request.upload || this.upload_request;
	eventSource.onprogress = this._uploadProgress(this);
    this.options = options;
    this.chunk_size = (1024 * 100 );
    this.slice_method = 'slice';
    this.range_start = 0;
    this.lastPosition = 0;
    this.timer; 
    if(this.range_start + this.chunk_size <= this.file.size){
        this.range_end = this.range_start + this.chunk_size;
        this._upload(this);
    } else {
        rectraceApp.chunkIsWaiting = true;
    }
};

ChunkedUploader.prototype = {

	_upload : function(r) {
        var self = r; 
        chunk = r.file[r.slice_method](r.range_start, r.range_end);	
		setTimeout(function() {
			
			var uploadOptions = Object.assign({}, r.options)
						
			r.upload_request.open('POST', r.options.url, true);
			r.upload_request.overrideMimeType('application/octet-stream');
			r.upload_request.setRequestHeader("Content-Type", "multipart/form-data");
			r.upload_request.setRequestHeader('X-FILE-NAME', encodeURIComponent(r.options.fileName));
			r.upload_request.setRequestHeader('Content-Range', 'bytes ' + r.range_start + '-' + r.range_end + (r.file.isLast ? '/' + r.file.size: ""));
			var reader = new FileReader();
			reader.onloadend = function(evt) {
				var blob = new Blob([reader.result], { type:chunk.type});
				r.upload_request.send(blob);
			};
			reader.readAsArrayBuffer(chunk);
		}, 20);
	},
	
	_uploadProgress:function(r){
        var self = this;
        
        return function(e) {
            var position = e.position || e.loaded;
            if( typeof  r.loaded == 'undefined' ){
                r.loaded = 0;
            } else {
                r.loaded += (position- self.lastPosition);
            }
            self.lastPosition = position;
            if(!r.file.isLast) return true;
           
            var total = r.file.size;
            
            self.total = total;
            r.percentComplete = (r.loaded  / total ) * 99;
            var percent = Math.floor(r.percentComplete);
            chrome.browserAction.setBadgeText({text:percent+"%"});
            chrome.browserAction.setPopup({popup: ''});
        }
    },
	
	_uploadSuccess : function(r){
        var self = r;
        return function(){
            if(r.upload_request.responseText.toLowerCase().indexOf('error') == -1){
                r.upload_error_count = 0;
                r.upload_failed_count = 0;
                r.lastPosition = 0;
                var id = r.upload_request.responseText.match(/id \d[0-9]*/);
                if(id){
                    id = id[0].substring(3);
                    var resid = r.upload_request.responseText.split("\n")[5].split(" ")[4];
						if(!rectraceApp.recordingState.isRecording){
							var now = Date.now();
							var duration = 0;
							if(rectraceApp.recordingState.startTime){
								duration = (now - rectraceApp.recordingState.startTime) / 1000;
							}
							duration += rectraceApp.recordingState.tempTime;
							
							 rectraceApp.sendUploadInfoToPage({
								id: id,
								rid: resid,
								file: r.file,
								duration: duration
							})
							
						}
                        rectraceApp.currentTabId = null;
                        rectraceApp.resetDefaults();
					return;
                }
                r.range_start = r.range_end;
                if(r.range_start + r.chunk_size < r.file.size){
                    r.range_end = r.range_start + r.chunk_size;
                    rectraceApp.chunkIsWaiting = false;
                    r._upload(r);
                } else if(r.file.isLast && r.range_start + r.chunk_size >= r.file.size){
                    r.range_end = r.file.size;
                    r._upload(r);
                } else {
                    rectraceApp.chunkIsWaiting = true;
                }
            } else {
                r.upload_error_count ++;
                if(r.upload_error_count <= 10){
                    r._upload(r);
                } else{
                    r._uploadFail(r, r.upload_request.responseText.toLowerCase())();
                }
            }
        }
        
	},
	
	_uploadFail : function (r, resp){
		var self = r;
		self.upload_error_count = 0;
		return function(e){
            rectraceApp.showNotification("An error occurred during uploading !");
            
            rectraceApp.recordingState.isFailed = true;
            var tracks = rectraceApp.currentStream.getTracks();
			if(tracks){
				for (var i = 0; i < tracks.length; ++i) {
					tracks[i].stop();
				}
			}
            rectraceApp.stopScreenRecording();
		}
	},
	
	_cancelUpload : function (r){
		var self = r;
		clearTimeout(self.timer);
		self.upload_failed_count = 0;
		self.upload_error_count = 0;
	},
	
	_tryAgainUpload : function(r){
		var self = r;
		self._upload(r);
	}
}
