
log = "";
(function () {

    if (window.hasShazoomRectraceExtRun)
        return true;
    window.hasShazoomRectraceExtRun = true;

    var rectraceApp = {
        cp_current_stopwatch: null,
        cp_ext_interval: null,
        init: function () {
            rectraceApp.bindEvents();
            rectraceApp.audio = new Audio(chrome.runtime.getURL("/assets/audios/shazoom-click.mp3"));
            if (location.href.indexOf("shazoom-extension/setup") > -1) {
                rectraceApp.requestDeviceAccess();
            }
        },

        bindEvents: function () {
            rectraceApp.bindOnMessage();
        },

        bindOnMessage: function () {
            chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
                if (request.ping) {
                    sendResponse({
                        pong: true
                    });
                    return;
                }

                if (request.appendHtml) {
                    rectraceApp.appendWebCamHtmlToCurrentTab();
                    /* if(!request.isWebCamRecording){
                        rectraceApp.appendHtmlToCurrentTab(request.time);
                    } else {
                        rectraceApp.appendWebCamHtmlToCurrentTab(request.time);
                    } */

                    return;
                }

                if (request.key == "appendRecordingHtml") {
                    var params = {};
                    params.type = request.type;
                    rectraceApp.appendRecordingHtml(request.type, function (showCamera) {
                        params.cameraEnabled = showCamera;
                        rectraceApp.showLoader(rectraceApp.startCapturing, params, "Recording")
                    });


                } else if (request.key == "removeWebCamPreview") {
                    rectraceApp.removeWebCamPreview();
                } else if (request.key == "appendSmallWebCamPreview") {
                    rectraceApp.appendRecordingHtmlForTab(true, true)
                } else if (request.key == "removeSmallWebCamPreview") {
                    rectraceApp.removeWebCamPreview();
                } else if (request.key == "stopStream") {
                    rectraceApp.stopPlugins();
                } else if (request.key == "getTitle") {
                    sendResponse({
                        title: document.title || location.href
                    });
                } else if (request.key == "stopWaiting") {
                    rectraceApp.cancellCapture()
                } else if (request.key == "requestDeviceAccess") {
                    rectraceApp.requestDeviceAccess();
                } else if (request.key == "removeIframe") {
                    rectraceApp.removeRequestDeviceAccessIframe();
                } else if (request.key == "reloadCameraIframe") {
                    rectraceApp.reloadCameraIframe();
                } else if (request.key == "appendGotIt") {
                    rectraceApp.appendGotItHtml();
                    rectraceApp.showGotIt();
                }
            });

            window.addEventListener('message', rectraceApp.receiveMessage);
        },

        requestDeviceAccess: function () {
            var container = document.createElement("div");
            container.innerHTML = '<div>' +
                '<div id="rectrace-app-camera" style="display:none"><iframe allow="microphone; camera" src="' + chrome.extension.getURL("requestDeviceAccess.html") + '"></iframe></div>' +
                '</div>';
            container.id = "rectrace-app-camera-ifr";
            var body = document.body;
            body.appendChild(container);
        },

        appendRecordingHtml: function (type, callback) {
            chrome.storage.sync.get(null, function (items) {
                var cameraEnabled = items["cameraEnabled"] === false ? false : true;
                var cameraPermitted = items["cameraPermitted"] === true ? true : false;
                var showCamera = cameraEnabled && cameraPermitted;

                rectraceApp.appendRecordingHtmlForTab(showCamera)

                if (typeof callback == "function") {
                    callback(showCamera);
                }
            })
        },

        appendRecordingHtmlForTab: function (showCamera, showPreview) {

            var container = document.createElement("div");
            var containerInner = document.createElement("div");
            if (showCamera) {
                var appCamera = document.createElement("div");
                var appIframe = document.createElement("iframe");
                appCamera.id = "rectrace-app-camera";
                appIframe.src = chrome.extension.getURL("camera.html");
                appIframe.id = "rectrace-app-camera-iframe"
                appIframe.allow = "microphone; camera"
                appCamera.appendChild(appIframe);
                containerInner.appendChild(appCamera);
				
				var stopBtn = document.createElement("button");
				stopBtn.type = "button";
				stopBtn.title = "Finish recording";
				stopBtn.id = "rectrace-app-stop-btn";
				stopBtn.innerHTML = "<i class='rectrace-app-camera-control-square'></i>";
				stopBtn.onclick = function(){
					chrome.extension.sendMessage({
						action: 'stopRecording'
					});
				}
				
				var controls = document.createElement("div");
				controls.className = "rectrace-app-camera-controls";
				controls.id = "rectrace-app-camera-controls";
				
				controls.appendChild(stopBtn);
				
				appCamera.appendChild(controls);
            }
            /*  if(showCamera && showPreview){
                 var appPreview = document.createElement("div");
                 appPreview.className = "rectrace-app-camera-large-preview";
                 appPreview.innerHTML = "<i></i><span>Live Preview</span>";
                 appPreview.style.display = "none";
                 appCamera.appendChild(appPreview);
             } */

            container.appendChild(containerInner);
            container.id = "rectrace-app-shazoom";
            var body = document.body;
            if (document.getElementById("rectrace-app-shazoom") == null) {
                body.appendChild(container);
                container.offsetWidth;
                setTimeout(function () {
                    container.classList.add("preview-appended");
                }, 100);

            }
			
			if(appCamera){
				rectraceApp.initeDragCamera(appCamera);
				rectraceApp.initResizeCamera(container,appCamera);
			}
			
			
        },
		initeDragCamera:function(camera){
			var pos1 = 0,pos2 = 0,pos3 = 0,pos4 = 0;
			var elmnt = null;

			camera.onmousedown = dragMouseDown;

			function dragMouseDown(e) {
				elmnt = camera;

				e = e || window.event;
				// get the mouse cursor position at startup:
				pos3 = e.clientX;
				pos4 = e.clientY;
				document.onmouseup = closeDragElement;
				// call a function whenever the cursor moves:
				document.onmousemove = elementDrag;
			}

			function elementDrag(e) {
				if (!elmnt || rectraceApp.cameraResizeIsActive == true) {
				  return;
				}

				e = e || window.event;
				// calculate the new cursor position:
				pos1 = pos3 - e.clientX;
				pos2 = pos4 - e.clientY;
				pos3 = e.clientX;
				pos4 = e.clientY;
				// set the element's new position:
				elmnt.style.top = elmnt.offsetTop - pos2 + "px";
				elmnt.style.left = elmnt.offsetLeft - pos1 + "px";
			}

			function closeDragElement() {
				/* stop moving when mouse button is released:*/
				document.onmouseup = null;
				document.onmousemove = null;
			}

			
		},
		initResizeCamera:function(container,camera){
			var element = null;
			var startX, startY, startWidth, startHeight;


			var both = document.createElement("div");
			both.className = "rectrace-app-camera-resizer";
			camera.insertBefore(both, camera.firstChild);
			both.addEventListener("mousedown", initDrag, false);

            function pauseEvent(e){
                if(e.stopPropagation) e.stopPropagation();
                if(e.preventDefault) e.preventDefault();
                e.cancelBubble=true;
                e.returnValue=false;
                return false;
            }
		  function initDrag(e) {
            e=e || window.event;
            pauseEvent(e);
			element = camera;

			startX = e.clientX;
			startY = e.clientY;
			startWidth = parseInt(
			  document.defaultView.getComputedStyle(element).width,
			  10
			);
			startHeight = parseInt(
			  document.defaultView.getComputedStyle(element).height,
			  10
			);
			document.documentElement.addEventListener("mousemove", doDrag, false);
			document.documentElement.addEventListener("mouseup", stopDrag, false);
		  }

		  function doDrag(e) {
			rectraceApp.cameraResizeIsActive = true;
			var width;
			if(e.clientX - startX > 0){				
				width = startWidth + (startX -  e.clientX )  + "px";
			}else{
				width = startWidth - (e.clientX - startX) + "px";
			}
			
			element.style.width = width;
			element.style.height = width;
		  }

		  function stopDrag() {
			rectraceApp.cameraResizeIsActive = false;
			document.documentElement.removeEventListener("mousemove", doDrag, false);
			document.documentElement.removeEventListener("mouseup", stopDrag, false);
		  }
			
		},
        appendWebCamHtmlToCurrentTab: function (time) {
            chrome.storage.sync.get(null, function (items) {
                var cameraEnabled = items["cameraEnabled"] === false ? false : true;
                var cameraPermitted = items["cameraPermitted"] === true ? true : false;
                var showCamera = cameraEnabled && cameraPermitted;
                //rectraceApp.appendRecordingHtmlForWebcam(true);

                rectraceApp.appendRecordingHtmlForTab(true);
                //rectraceApp.removeWebCamPreviewBlock();
                //rectraceApp.buildWebCamControls(time)
            });
        },

        appendRecordingHtmlForWebcam: function (showCamera) {
            var container = document.createElement("div");
            var containerInner = document.createElement("div");
            if (showCamera) {
                var appCamera = document.createElement("div");
                var appIframe = document.createElement("iframe");
                appCamera.id = "rectrace-app-camera-large";
                appIframe.id = "rectrace-app-camera-large-iframe";
                appIframe.src = chrome.extension.getURL("cameraLarge.html");
                appIframe.allow = "microphone; camera";
                containerInner.className = "rectrace-app-inner-overlay";
                appCamera.appendChild(appIframe);
                var appPreview = document.createElement("div");
                appPreview.className = "rectrace-app-camera-large-preview";
                appPreview.innerHTML = "<i></i><span>Live Preview</span>";
                appCamera.appendChild(appPreview);
                containerInner.appendChild(appCamera);
            }

            container.appendChild(containerInner);
            container.id = "rectrace-app-shazoom";
            var body = document.body;
            if (document.getElementById("rectrace-app-shazoom") == null) {
                body.appendChild(container);
            }
        },

        removeWebCamPreviewBlock: function () {

            var container = document.getElementById("rectrace-app-shazoom");
            if (container == null) {
                return;
            }
            var preview = container.getElementsByClassName("rectrace-app-camera-large-preview");
            if (preview && preview.length) {
                for (var el = 0; el < preview.length; el++) {
                    preview[el].parentNode.removeChild(preview[el]);
                }
            }
        },
        removeWebCamPreview: function () {
            var container = document.getElementById("rectrace-app-shazoom")

            if (container == null) {
                return;
            }

            // var preview = container.getElementsByClassName("rectrace-app-camera-large-preview");
            //if(preview && preview.length){
            container.parentNode.removeChild(container);
            //}
        },
        stopPlugins: function () {

            if (rectraceApp.cp_current_stopwatch) {
                rectraceApp.cp_current_stopwatch.destroy();
                rectraceApp.cp_current_stopwatch = null;
            }

            if (document.getElementById("rectrace-app-shazoom") != null) {
                document.body.removeChild(document.getElementById("rectrace-app-shazoom"));
            }

        },

        cancellCapture: function () {
            if (document.getElementById("rectrace-app-shazoom") != null) {
                document.body.removeChild(document.getElementById("rectrace-app-shazoom"));
            }
            rectraceApp.removeLoader();
            clearInterval(rectraceApp.cp_ext_interval);
            chrome.extension.sendMessage({
                action: 'cancellRecording'
            });

        },

        startCountDown: function (callback, params, timeElementId) {
            var timeElement = document.getElementById(timeElementId)
            rectraceApp.cp_ext_interval = setInterval(function () {
                var time = parseInt(timeElement.textContent || timeElement.innerText);
                time = time - 1;
                rectraceApp.beep();
                if (time > 0) {
                    timeElement.innerHTML = time;
                } else {
                    rectraceApp.removeLoader();
                    if (typeof callback == "function") {
                        callback(params);
                    }
                    clearInterval(rectraceApp.cp_ext_interval);
                }
            }, 1000)
        },

        beep: function () {
            rectraceApp.audio.volume = 0.2;
            rectraceApp.audio.play();
        },

        showLoader: function (callback, params, word) {
            var container = document.createElement("div");
            rectraceApp.removeWebCamPreviewBlock();
            container.innerHTML = '<div class="countdown"><span>' + word + ' will begin in</div><div class="loading"><b id="countdown-seconds">3</b><div class="cssload-speeding-wheel"></div></div><button id="rectrace-app-cancel">Cancel</button>';
            container.id = "rectrace-app-loader";
            var body = document.body;
            var overlay = document.createElement("div");
            overlay.id = "rectrace-app-overlay";
            if (document.getElementById("rectrace-app-loader") == null) {
                body.appendChild(container);
            }
            if (document.getElementById("rectrace-app-overlay") == null) {
                body.appendChild(overlay);
            }

            if (document.getElementById("rectrace-app-cancel") != null) {
                document.getElementById("rectrace-app-cancel").onclick = function () {
                    rectraceApp.cancellCapture();
                }
            }
            rectraceApp.startCountDown(callback, params, "countdown-seconds");
        },

        removeLoader: function () {
            var loader = document.getElementById("rectrace-app-loader");
            var overlay = document.getElementById("rectrace-app-overlay");
            if (loader)
                loader.parentNode.removeChild(loader);
            if (overlay)
                overlay.parentNode.removeChild(overlay);
        },

        startCapturing: function (params) {
            setTimeout(function () {
                chrome.extension.sendMessage({
                    action: 'startCapture',
                    type: params.type,
                    enabled: params.cameraEnabled
                });
            }, 300)
        },

        removeRequestDeviceAccessIframe: function () {
            if (document.getElementById("rectrace-app-camera-ifr") != null) {
                document.body.removeChild(document.getElementById("rectrace-app-camera-ifr"));
            }
        },

        reloadCameraIframe: function () {
            var iframe = document.getElementById("rectrace-app-camera-iframe");
            if (iframe == null) {
                iframe = document.getElementById("rectrace-app-camera-large-iframe");
                if (iframe == null) {
                    return;
                }
            }
            iframe.src = iframe.src;
        },

        appendGotItHtml: function () {
            var container = document.createElement("div");
            container.innerHTML = '<div>' +
                '<div class="rectrace-tip rectrace-tip-bottom-left"><div><h3>Record yourself</h3><p>Include your face in your recordings by turning the camera on from the extension before you click record.</p></div></div>' +
                '<div class="rectrace-tip-cam"><i class="icon-webcam-on"></i></div>' +
                '</div>';
            container.id = "rectrace-app-shazoom";
            var body = document.body;
            if (document.getElementById("rectrace-app-shazoom") == null) {
                body.appendChild(container);
            }
        },

        showGotIt: function () {
            var container = document.createElement("div");
            container.innerHTML = '<div class="countdown"><span style="font-size: 64px; letter-spacing: 0;width:320px; margin:20px auto; display:block; line-height: 64px;">Welcome!</span><span style="width:440px; margin:0 auto; display:block;font-size:20px;font-weight:normal;line-height:25px">Here a couple of tips to help you get started</span></div><button id="rectrace-app-gotit">Got It</button>';
            container.id = "rectrace-app-loader";
            var body = document.body;
            var overlay = document.createElement("div");;
            overlay.id = "rectrace-app-overlay";
            if (document.getElementById("rectrace-app-loader") == null) {
                body.appendChild(container);
            }
            if (document.getElementById("rectrace-app-overlay") == null) {
                body.appendChild(overlay);
            }
            if (document.getElementById("rectrace-app-gotit") != null) {
                document.getElementById("rectrace-app-gotit").onclick = function () {
                    rectraceApp.gotit();
                }
            }
        },

        gotit: function () {
            var params = {};
            params["gotIt"] = true;
            chrome.storage.sync.set(params, function () {});
            if (document.getElementById("rectrace-app-shazoom") != null) {
                document.body.removeChild(document.getElementById("rectrace-app-shazoom"));
            }
            rectraceApp.removeLoader();
        }
    }

    function Cp_Stopwatch(id, time) {
        this.elem = document.getElementById(id);
        this.minutes = 0;
        this.seconds = 0;
        if (time) {
            time = Math.round(time);
            if (time < 60) {
                this.seconds = Math.round(time)
            } else {
                this.minutes = Math.floor(time / 60);
                this.seconds = time - minutes * 60;
            }
        }
        this.t = null;
        this.elem.textContent = "00:00";
        this.start(this);
    }

    Cp_Stopwatch.prototype = {
        add: function () {
            this.seconds++;
            if (this.seconds >= 60) {
                this.seconds = 0;
                this.minutes++;
            }
            this.elem.textContent = (this.minutes ? (this.minutes > 9 ? this.minutes : "0" + this.minutes) : "00") + ":" + (this.seconds > 9 ? this.seconds : "0" + this.seconds);
            this.timer();
        },

        timer: function () {
            var that = this;
            this.t = setTimeout(function () {
                that.add();
            }, 1000);
        },

        start: function () {
            this.timer(this)
        },

        stop: function () {
            clearTimeout(this.t);
        },

        clear: function () {
            this.elem.textContent = "00:00";
            this.seconds = 0;
            this.minutes = 0;
        },

        destroy: function () {
            this.stop();
        }

    };

    rectraceApp.init();
})();